我现在已经绞尽脑汁待了几天,并且已经用尽了我对这个问题的研究。
一点背景:我有一个rails应用程序在生产中完全正常工作。我在不同目录下的同一台服务器上添加了一个临时环境。我能够到达临时站点。
我注意到了什么:
问题:
我的暂存网站似乎认为它是一个生产网站。我觉得我没有在某处正确设置暂存环境。一些奇怪的事情正在发生:
代码:(我已经取代了实际的域名/ IP)
配置/ deploy.rb
# config valid only for current version of Capistrano
lock '3.3.5'
set :stages, %w(production staging)
set :default_stage, 'staging'
set :repo_url, 'git@github.com:test/test.git'
set :user, 'deploy'
set :linked_dirs, %w{log tmp/pids tmp/cache tmp/sockets public/system/members}
namespace :deploy do
%w[start stop restart].each do |command|
desc 'Manage Unicorn'
task command do
on roles(:app), in: :sequence, wait: 1 do
execute "/etc/init.d/unicorn_#{fetch(:application)} #{command}"
end
end
end
after :publishing, :restart
end
配置/部署/ staging.rb
set :rails_env, 'staging'
set :application, 'test_staging'
set :deploy_to, '/var/www/staging.test.co'
set :branch, 'staging'
role :app, %w{deploy@IP_HERE}
role :web, %w{deploy@IP_HERE}
role :db, %w{deploy@IP_HERE}
配置/ unicorn.rb
if ENV["RAILS_ENV"] == "production"
root = "/var/www/test.co/current"
else
root = "/var/www/staging.test.co/current"
end
working_directory root
pid "#{root}/tmp/pids/unicorn.pid"
stderr_path "#{root}/log/unicorn.log"
stdout_path "#{root}/log/unicorn.log"
if ENV["RAILS_ENV"] == "production"
listen "/tmp/unicorn.test.sock"
else
listen "/tmp/unicorn.test_staging.sock"
end
worker_processes 1
timeout 30
[在服务器上] /etc/init.d/unicorn_test_staging
#!/bin/sh
### BEGIN INIT INFO
# Provides: unicorn
# Required-Start: $remote_fs $syslog
# Required-Stop: $remote_fs $syslog
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: Manage unicorn server
# Description: Start, stop, restart unicorn server for a specific application.
### END INIT INFO
set -e
# Feel free to change any of the following variables for your app:
TIMEOUT=${TIMEOUT-60}
APP_ROOT=/var/www/staging.test.co/current
PID=$APP_ROOT/tmp/pids/unicorn.pid
CMD="cd $APP_ROOT; bundle exec unicorn -D -c $APP_ROOT/config/unicorn.rb -E staging"
AS_USER=deploy
set -u
OLD_PIN="$PID.oldbin"
sig () {
test -s "$PID" && kill -$1 `cat $PID`
}
oldsig () {
test -s $OLD_PIN && kill -$1 `cat $OLD_PIN`
}
run () {
if [ "$(id -un)" = "$AS_USER" ]; then
eval $1
else
su -c "$1" - $AS_USER
fi
}
case "$1" in
start)
sig 0 && echo >&2 "Already running" && exit 0
run "$CMD"
;;
stop)
sig QUIT && exit 0
echo >&2 "Not running"
;;
force-stop)
sig TERM && exit 0
echo >&2 "Not running"
;;
restart|reload)
sig HUP && echo reloaded OK && exit 0
echo >&2 "Couldn't reload, starting '$CMD' instead"
run "$CMD"
;;
upgrade)
if sig USR2 && sleep 2 && sig 0 && oldsig QUIT
then
n=$TIMEOUT
while test -s $OLD_PIN && test $n -ge 0
do
printf '.' && sleep 1 && n=$(( $n - 1 ))
done
echo
if test $n -lt 0 && test -s $OLD_PIN
then
echo >&2 "$OLD_PIN still exists after $TIMEOUT seconds"
exit 1
fi
exit 0
fi
echo >&2 "Couldn't upgrade, starting '$CMD' instead"
run "$CMD"
;;
reopen-logs)
sig USR1
;;
*)
echo >&2 "Usage: $0 "
exit 1
;;
esac
配置/ database.yml的
development:
adapter: postgresql
encoding: unicode
database: test_dev
host: localhost
pool: 5
username: test
password: password
staging:
adapter: postgresql
encoding: unicode
database: test_staging
production:
adapter: postgresql
encoding: unicode
database: test_production
如果您需要任何其他代码来帮助我在此处找到问题,请与我们联系。我感谢任何人的帮助。
谢谢!
答案 0 :(得分:0)
您的登台服务器很可能正在调用生产服务器的路由,因为它们位于同一主机上。
您需要确保使用以下命令设置子文件夹:config.relative_url_root或RAILS_RELATIVE_URL_ROOT环境变量。
中查找relative_url_root答案 1 :(得分:0)
终于弄明白了。我在屏幕上写了Rails.env,它正在返回" production"在我的临时站点上。这就是它使用我的生产数据库和日志的原因。
我最初忘记在第一次创建暂存站点时将/etc/init.d/unicorn_myapp中的unicorn init脚本更改为-E staging。我在几天前将其设置为暂存,并没有解决问题。
因此,出于绝望,我进入了我的服务器并尝试了一个完整的独角兽停止并开始
sudo service unicorn_myapp stop
sudo service unicorn_myapp start
并解决了这个问题!我的Rails.env开始回归" staging"现在一切正常。
TLDR:如果您更改了unicorn init脚本,请务必停止并启动unicorn应用程序。简单的重启并不适合我。